/*******************************/
/*generate_parm.cpp            */

//Given a list of preprocessed files as input and a file as output,
//thiis generates the header file that defines the module
//parameters.


#include <iostream>
#include <string>
#include <fstream>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

using namespace std;


string inline getline(ifstream *file)
{
  if (!file) {return "";}
  char c;
  string line;
  bool status = file -> get(c);
  if (!status) {return "";}
  while (status)
    {
      if (c == '\n')
	{
	  return line;
	}
      line += c;
      status = file -> get(c);
    }
  return line;
  
}
string removeChar(string s,char c)
{
  string ans;
  for (int i=0;i<s.size();i++)
    {
      if (s[i] != c)
	{
	  ans += s[i];
	}
    }
  return (ans);
}


int main(int argc,char *argv[])
{
  if (argc < 3)
    {
      cout <<"Usage : generate_parm <file1>...<filen> <output>"<<endl;
      return -1;
    }
  
  int numfiles = argc - 1;
  string min;
  string max;
  string type;
  string headerfile = argv[numfiles];
  string infile;

  string param_struct = "PITS_parameter pits_parameters[] ={\n";
  string param_prototypes;
  int npar = 0;
  for (int i=1;i<numfiles;i++)
    {
      infile = argv[i];
      cout <<"Current infile is:"<<infile<<endl;
      //read in file.

      ifstream file(infile.c_str());

      if (!file) {cout <<"File doesn't exist!"<<endl;exit(EXIT_FAILURE);}
      
      string line = getline(&file);

      while (!file.eof())
	{
	  //cout <<"line:"<<line<<endl;
	  

	  string::size_type idx = line.find("__PITS_parm_set_");

	  if (idx != string::npos)
	    {
	      cout <<"line has parameter:"<<line<<endl;
	      string::size_type idx2 = line.find("(",idx);

	      if (idx2 != string::npos)
		{
		  npar++;
		  string parname;
		  for (int j=idx+16;j<idx2;j++)
		    {
		      parname += line[j];
		    }
		  parname = removeChar(parname,' ');
		  cout <<"parametername:"<<parname<<endl;
		  idx = line.find(",",idx);
		  idx2 = line.find(",",idx+1);
		  cout <<"getting type"<<endl;
		  string partype = "";
		  
		  for (int j=idx+1;j<idx2;j++)
		    {
		      partype+= line[j];
		    }
		  cout <<"parametertype:"<<partype<<endl;
		  partype = removeChar(partype,'"');
		  partype = removeChar(partype,' ');
		  cout <<"parametertype:"<<partype<<endl;
		  if (partype.length() == 1)
		    {
		      min ="1";
		      max ="1";
		      type = partype[0];
		    }
		  else
		    {
		      idx = partype.find("-");
		      min ="";
		      max ="";
		      for (int j=0;j<idx;j++)
			{
			  min += partype[j];
			}
		      for (int j=idx+1;j<partype.length()-1;j++)
			{
			  max += partype[j];
			}
		      type = partype[partype.length()-1];
		    }
		  param_prototypes += "void __PITS_parm_set_";
		  param_prototypes += parname;
		  param_prototypes += "(void *newval);\n";

		  param_struct += "{\""+parname;
		  param_struct += "\",__PITS_parm_set_";
		  param_struct += parname;
		  param_struct += ",";
		  param_struct += "\""+partype+"\",";
		  param_struct += "\'"+type+"\',";
		  param_struct += min+",";
		  param_struct += max+"},\n";
		  

		}

	    }
	  //__PITS_parm_set_name(
	  line = getline(&file);
	} //while (!file.eof())
    }
  param_struct += "{\"\",NULL,\"\",\'0\',0,0}};\n";
  param_struct += "#";
  param_struct += "define npits_parameters ";
      
      
  cout <<"Structure :\n"<<param_struct<<endl;
  cout <<"Prototypes:\n"<<param_prototypes<<endl;

  
  cout <<"Outfile header file:"<<headerfile<<endl;

  ofstream ofile(headerfile.c_str());

  ofile << "#include <misc/pits_state.h>" <<endl;
  ofile << "#include <misc/pits_param.h>" <<endl;
  ofile << param_prototypes <<endl;
  ofile << param_struct << npar << endl;
  ofile << "int init_linux_parameters(dev_info_t *dip)"<<endl;
  ofile << "\{" <<endl;
  ofile << "sun_linux_state *instance_state = NULL;int instance;"<<endl;
  ofile << "getInstanceFReturn(dip,instance_state);"<<endl;
  ofile << "instance_state -> npar = npits_parameters;"<<endl;
  ofile << "instance_state -> par  = pits_parameters;"<<endl;
  ofile << "return DDI_SUCCESS;"<<endl;
  ofile << "}"<<endl;


  return 0;
}
