#ifndef _LINUX_KERNEL_H
#define _LINUX_KERNEL_H


#include <sys/ksynch.h>


/*
extern int sprintf(char * buf, const char * fmt, ...)
        __attribute__ ((format (printf, 2, 3)));
*/

extern int printk(const char * fmt, ...)
        __attribute__ ((format (printf, 1, 2)));
	

/*
#define min(x,y) ({ \
        const typeof(x) _x = (x);       \
        const typeof(y) _y = (y);       \
        (void) (&_x == &_y);            \
        _x < _y ? _x : _y; })
*/

#define KERN_EMERG      "<0>"   /* system is unusable                   */
#define KERN_ALERT      "<1>"   /* action must be taken immediately     */
#define KERN_CRIT       "<2>"   /* critical conditions                  */
#define KERN_ERR        "<3>"   /* error conditions                     */
#define KERN_WARNING    "<4>"   /* warning conditions                   */
#define KERN_NOTICE     "<5>"   /* normal but significant condition     */
#define KERN_INFO       "<6>"   /* informational                        */
#define KERN_DEBUG      "<7>"   /* debug-level messages                 */


/*** the following is from linux/kdev_t.h ***/
#define MINORBITS       8
#define MINORMASK       ((1U << MINORBITS) - 1)
#define MAJOR(dev)      ((unsigned int) ((dev) >> MINORBITS))
#define MINOR(dev)      ((unsigned int) ((dev) & MINORMASK))
/********************************************/


/*** this comes from linux/compatmac.h ***/
/*** I have no idea where the wait_queue is defined. ***/
/*** #define wait_queue_head_t     struct wait_queue *   ***/

/*****************************************/
typedef struct wait_queue
{
  int initialized;
  kmutex_t *queue_mutex;
  kcondvar_t *queue_condvar;
}wait_queue_head_t;

//#define wait_queue_head_t struct waitqueue

/*
extern struct notifier_block *panic_notifier_list;
NORET_TYPE void panic(const char * fmt, ...)
     __attribute__ ((NORET_AND format (printf, 1, 2)));
     asmlinkage NORET_TYPE void do_exit(long error_code)
     ATTRIB_NORET;
*/

void linux_panic(const char *fmt,...)
{
  getGlobal() -> panic = TRUE;
  printk(fmt,...);
}


#endif
