#ifndef _LINUX_WAIT_H
#define _LINUX_WAIT_H

#include <sys/ksynch.h>

/****************************************/
#include <linux/kernel.h>



static inline void init_waitqueue_head(wait_queue_head_t *q)
{
  q -> queue_mutex   = kmalloc(sizeof(kmutex_t),0);
  q -> queue_condvar = kmalloc(sizeof(kcondvar_t),0);
  //do this later, mark this memory as a mutex and condition.
  //*********
  mutex_init(q -> queue_mutex,NULL,MUTEX_DRIVER,NULL);
  cv_init(q -> queue_condvar,NULL,CV_DRIVER,NULL);
  q -> initialized = TRUE;
}
/****************************************/

#define DECLARE_WAIT_QUEUE_HEAD(name) wait_queue_head_t name = {initialized : FALSE, queue_mutex : NULL, queue_condvar : NULL}; 
/***        wait_queue_head_t name = __WAIT_QUEUE_HEAD_INITIALIZER(name) ***/


#endif
