#ifndef _I386_SEMAPHORE_H
#define _I386_SEMAPHORE_H

/*sun include*/
#include <sys/semaphore.h>
#include <linux/kernel.h>
#include <asm/atomic.h>
#include <linux/sched.h>

/*make the semaphore the sun type*/



struct sun_semaphore
{
  void * _opaque[2];   /* 2 words on 4 byte alignment */
};


//we need to fix semaphore so that it acts more like a linux semaphore to
//the driver.  Solaris semaphores don't allow the count variable to be
//referenced or discovered, whereas some linux driver code, such as
//the scsi_logging code requires it.
//Guess we need a lower level implementation of semaphores using
//solaris primitives....
struct semaphore
{
  int initialvalue;
  int initialized;  
  //struct sun_semaphore sun_sema;
  kmutex_t mutex;
  kcondvar_t cv_wait;
  atomic_t count;
  //int count;
};
/*
{
       atomic_t count;
       int sleepers;
       wait_queue_head_t wait;
};
*/
/*
#define __SEMAPHORE_INITIALIZER(name,count)  \
{ ATOMIC_INIT(count), 0, __WAIT_QUEUE_HEAD_INITIALIZER((name).wait) \
	__SEM_DEBUG_INIT(name) }
*/
#define __SEMAPHORE_INITIALIZER(name,count) \
          {initialvalue : count, \
           initialized  : FALSE}                            

#define __DECLARE_SEMAPHORE_GENERIC(name,count) \
          struct semaphore name = __SEMAPHORE_INITIALIZER(name,count)
          
//         struct semaphore name = __SEMAPHORE_INITIALIZER(name,count)

#define DECLARE_MUTEX(name) __DECLARE_SEMAPHORE_GENERIC(name,1)

#define DECLARE_MUTEX_LOCKED(name) __DECLARE_SEMAPHORE_GENERIC(name,0)


void linux_sema_init(struct semaphore *sem,int val);

//static inline void linux_sema_init (struct semaphore *sem, int val)
//{
// int error=0; 
  /* this is the sun call for semaphores... */ 
  /* int sema_init(sema_t *sp, unsigned int count, int type, void * arg);*/ 

  //printk("inside linux_sema_init");
//  if (sem == NULL)
//    {
//      printk("warning null pointer to semaphore!");
//    }
//  else
//    {
//      sema_init((ksema_t*)&(sem -> sun_sema),val,NULL,SEMA_DRIVER,NULL); 
//   
//      if (error != 0) 
//	{ 
//	  printk("error initializing semaphore"); 
//	  sem = NULL; 
//	}
//      sem -> initialized = TRUE;
//    }
  //printk("done linux sema_init");
//}

static inline void init_MUTEX (struct semaphore *sem)
{
	linux_sema_init(sem, 1);
}

static inline void init_MUTEX_LOCKED (struct semaphore *sem)
{
	linux_sema_init(sem, 0);
}



int down_interruptible(struct semaphore *sem);

//static inline int down_interruptible(struct semaphore * sem)
//{
//  int status = 0;
//  printk("inside down_interruptible"); 
//  if (sem == NULL)
//    {
//      printk("warning, null semaphore!");
      /*since one signifies unable to get a lock,*/
      /*return it when this error occurs */
//      return (1);
//    }
//  if (sem -> initialized == FALSE)
//    {
//      printk("uninitialized semaphore");
//      linux_sema_init(sem,sem -> initialvalue);
//    }
//  
//  status = sema_p_sig((ksema_t *)&(sem -> sun_sema) );
//  
//  if (status == 1) 
//    {
//      printk("down interruptible() : signal detected....\n");
//      current -> sigpending = 1;
//    }
//  printk("done down_interrutpible : %d",status);  
//   
//  return status;
//}

void up(struct semaphore *sem);
/*
static inline void up(struct semaphore * sem)
{
  printk("inside up");
  if (sem == NULL)
    {
      printk("Warning, null semaphore!");
      return;
    }
  if (sem -> initialized == FALSE)
    {
      printk("uninitialized semaphore");
      linux_sema_init(sem,sem -> initialvalue);
    }
  sema_v((ksema_t *)&(sem -> sun_sema));
  
  printk("done inside up"); 
}
*/
void down(struct semaphore *sem);
/*
static inline void down(struct semaphore * sem)
{
  printk("inside down");
  if (sem == NULL)
    {
      printk("Warning, null semaphore!");
      return;
    }
  
  if (sem -> initialized == FALSE)
    {
      linux_sema_init(sem,sem -> initialvalue);
    }
  sema_p((ksema_t *)&(sem -> sun_sema));
  
  printk("done down"); 

}
*/
struct rw_semaphore
{
  int dummy;
};

#endif
