#ifndef _BLK_H
#define _BLK_H

#include <linux/blkdev.h>
#include <linux/locks.h>
#include <linux/config.h>
#include <linux/spinlock.h>


//other includes that don't seem to make it into drivers....
#include <linux/blkpg.h>

//#define io_request_lock getGlobal() -> _io_request_lock
extern spinlock_t io_request_lock;

static inline void blkdev_dequeue_request(struct request * req)
{
  //struct list_head *element = NULL;
  //DEBUGCMD(printk("inside blkdev_dequeue_request\n"));
  list_del(&(req -> queue));
  //DEBUGCMD(printk("done blkdev_dequeue_request\n"));
}

int end_that_request_first(struct request *req, int uptodate, char *name);
void end_that_request_last(struct request *req);

#if defined(MAJOR_NR) || defined(IDE_DRIVER)


#if (SCSI_DISK_MAJOR(MAJOR_NR))

#define DEVICE_NAME "scsidisk"
#define TIMEOUT_VALUE (2*HZ)
#define DEVICE_NR(device) (((MAJOR(device) & SD_MAJOR_MASK) << (8 - 4)) + (MINOR(device) >> 4))

#endif


#ifndef DEVICE_NAME
#define DEVICE_NAME "unknown"
#endif


#ifndef CURRENT
#define CURRENT blkdev_entry_next_request(&blk_dev[MAJOR_NR].request_queue.queue_head)
//#define CURRENT NULL

#endif

#ifndef QUEUE_EMPTY
#define QUEUE_EMPTY list_empty(&blk_dev[MAJOR_NR].request_queue.queue_head)
#endif

#ifdef DEVICE_INTR
static void (*DEVICE_INTR)(void) = NULL;
#endif

#define SET_INTR(x) (DEVICE_INTR = (x))


#ifdef DEVICE_INTR
#define CLEAR_INTR SET_INTR(NULL)
#else
#define CLEAR_INTR
#endif

#define INIT_REQUEST \
        printk("checking queue"); \
	if (QUEUE_EMPTY) {\
                printk("queue empty"); \
		CLEAR_INTR; \
		return; \
	} \
        printk("checking major"); \
        if (CURRENT == NULL) {printk("NULL Current");}\
	if (MAJOR(CURRENT->rq_dev) != MAJOR_NR) \
		{printk(DEVICE_NAME ": request list destroyed"); return;} \
        printk("checking current-> bh"); \
        if (CURRENT->bh) { \
		if (!buffer_locked(CURRENT->bh)) \
			{printk(DEVICE_NAME ": block not locked");return;} \
	printk("done init_request"); \
        }

//#define INIT_REQUEST



static inline void end_request(int uptodate) 
{
  	struct request *req = CURRENT;
	if (end_that_request_first(req, uptodate, DEVICE_NAME))
		return;
	blkdev_dequeue_request(req);

	end_that_request_last(req);
	bzero(req,sizeof (struct request));
	kfree(req);
}

#endif /* defined(MAJOR_NR) || defined(IDE_DRIVER) */
#endif /* _BLK_H */
