#ifndef _LINUX_INIT_H
#define _LINUX_INIT_H


#include <misc/pits_init.h>
#include <misc/pits_state.h>
//#include <misc/sunlinux.h>
#include <misc/globals.h>
/*
 * Mark functions and data as being only used at initialization
 * or exit time.
 */

#define __init 
#define __exit
#define __initdata

#define __devinit
#define __devinitdata



#define init_module(x) linux_init_module(void)
#define cleanup_module(x) linux_cleanup_module(void)

#define __setup(str,func) /* nothing */

#define module_init(x) \
   int linux_init_module(void) \
   {\
      return x(); \
   }

                   
#define module_exit(x)  \
   void linux_cleanup_module(void) \
   {\
      x(); \
   }

int init_linux_parameters(dev_info_t *dip);

#endif
