#ifndef _LINUX_KERNEL_H
#define _LINUX_KERNEL_H

#ifdef __KERNEL__

//#ifndef va_list
#include <stdarg.h> /*for va_list*/
//#endif

/* Optimization barrier */
/* The "volatile" is due to gcc bugs */
/* dunno if this is a problem for solaris? */
/*#define barrier() __asm__ __volatile__("": : :"memory") */
#define barrier() ;

#include <sys/ksynch.h>


/*
extern int sprintf(char * buf, const char * fmt, ...)
        __attribute__ ((format (printf, 2, 3)));
*/

extern int linux_sprintf(char * buf,const char *fmt, ...);
extern int linux_vsprintf(char *buf, const char *, va_list);
extern int printk(const char * fmt, ...);
//        __attribute__ ((format (printf, 1, 2)));
	
extern unsigned long simple_strtoul(const char *,char **,unsigned int);

/*
#define min(x,y) ({ \
        const typeof(x) _x = (x);       \
        const typeof(y) _y = (y);       \
        (void) (&_x == &_y);            \
        _x < _y ? _x : _y; })
*/

#define KERN_EMERG      "<0>"   /* system is unusable                   */
#define KERN_ALERT      "<1>"   /* action must be taken immediately     */
#define KERN_CRIT       "<2>"   /* critical conditions                  */
#define KERN_ERR        "<3>"   /* error conditions                     */
#define KERN_WARNING    "<4>"   /* warning conditions                   */
#define KERN_NOTICE     "<5>"   /* normal but significant condition     */
#define KERN_INFO       "<6>"   /* informational                        */
#define KERN_DEBUG      "<7>"   /* debug-level messages                 */

#define FASTCALL(x) x


/*** the following is from linux/kdev_t.h ***/
//use solaris's getmajor and get minor for the MAJOR and MINOR macros.


#define MINORBITS       8
#define MINORMASK       ((1U << MINORBITS) - 1)

//#define MAJOR(dev)      ((unsigned int) getmajor(dev))
//#define MINOR(dev)      ((unsigned int) getminor(dev))
//#define MAJOR(dev)      ((unsigned int) ((dev) >> MINORBITS))
//#define MINOR(dev)      ((unsigned int) ((dev) & MINORMASK))
/********************************************/


/*** this comes from linux/compatmac.h ***/
/*** I have no idea where the wait_queue is defined. ***/
/*** #define wait_queue_head_t     struct wait_queue *   ***/

/*****************************************/
typedef struct wait_queue
{
  int initialized;
  int numwaiting;
  kmutex_t queue_mutex;
  kcondvar_t queue_condvar;

}wait_queue_head_t;

//#define wait_queue_head_t struct waitqueue


#endif /* __KERNEL__ */

#define SI_LOAD_SHIFT	16
struct sysinfo {
	long uptime;			/* Seconds since boot */
	unsigned long loads[3];		/* 1, 5, and 15 minute load averages */
	unsigned long totalram;		/* Total usable main memory size */
	unsigned long freeram;		/* Available memory size */
	unsigned long sharedram;	/* Amount of shared memory */
	unsigned long bufferram;	/* Memory used by buffers */
	unsigned long totalswap;	/* Total swap space size */
	unsigned long freeswap;		/* swap space still available */
	unsigned short procs;		/* Number of current processes */
	unsigned short pad;		/* explicit padding for m68k */
	unsigned long totalhigh;	/* Total high memory size */
	unsigned long freehigh;		/* Available high memory size */
	unsigned int mem_unit;		/* Memory unit size in bytes */
	char _f[20-2*sizeof(long)-sizeof(int)];	/* Padding: libc5 uses this.. */
};

void linux_panic(const char *fmt,...);

//NORET_TYPE void complete_and_exit(struct completion *, long)
//	ATTRIB_NORET;

struct completion;
void complete_and_exit(struct completion *, long);

#endif
