#ifndef _LINUX_STAT_H
#define _LINUX_STAT_H

#ifdef __KERNEL__

//#include <asm/stat.h>

#endif

#if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2)

#ifndef S_IFMT
   #define S_IFMT  00170000
#endif

#ifndef S_IFSOCK
   #define S_IFSOCK 0140000
#endif

#ifndef S_IFLNK
   #define S_IFLNK	 0120000
#endif

#ifndef S_IFREG
   #define S_IFREG  0100000
#endif

#ifndef S_IFBLK
   #define S_IFBLK  0060000
#endif

#ifndef S_IFDIR
   #define S_IFDIR  0040000
#endif

#ifndef S_IFCHR
   #define S_IFCHR  0020000
#endif

#ifndef S_IFIFO
   #define S_IFIFO  0010000
#endif

#ifndef S_ISUID
   #define S_ISUID  0004000
#endif

#ifndef S_ISGID
   #define S_ISGID  0002000
#endif

#ifndef S_ISVTX
   #define S_ISVTX  0001000
#endif

#ifndef S_ISLNK
   #define S_ISLNK(m)	(((m) & S_IFMT) == S_IFLNK)
#endif

#ifndef S_ISREG
   #define S_ISREG(m)	(((m) & S_IFMT) == S_IFREG)
#endif

#ifndef S_ISDIR
   #define S_ISDIR(m)	(((m) & S_IFMT) == S_IFDIR)
#endif

#ifndef S_ISCHR
   #define S_ISCHR(m)	(((m) & S_IFMT) == S_IFCHR)
#endif

#ifndef S_ISBLK
   #define S_ISBLK(m)	(((m) & S_IFMT) == S_IFBLK)
#endif

#ifndef S_ISFIFO
   #define S_ISFIFO(m)	(((m) & S_IFMT) == S_IFIFO)
#endif

#ifndef S_ISSOCK
   #define S_ISSOCK(m)	(((m) & S_IFMT) == S_IFSOCK)
#endif

#define S_IRWXU 00700
#define S_IRUSR 00400
#define S_IWUSR 00200
#define S_IXUSR 00100

#define S_IRWXG 00070
#define S_IRGRP 00040
#define S_IWGRP 00020
#define S_IXGRP 00010

#define S_IRWXO 00007
#define S_IROTH 00004
#define S_IWOTH 00002
#define S_IXOTH 00001

#endif

#ifdef __KERNEL__
#define S_IRWXUGO	(S_IRWXU|S_IRWXG|S_IRWXO)
#define S_IALLUGO	(S_ISUID|S_ISGID|S_ISVTX|S_IRWXUGO)
#define S_IRUGO		(S_IRUSR|S_IRGRP|S_IROTH)
#define S_IWUGO		(S_IWUSR|S_IWGRP|S_IWOTH)
#define S_IXUGO		(S_IXUSR|S_IXGRP|S_IXOTH)
#endif

#endif
