#ifndef _LINUX_WAIT_H
#define _LINUX_WAIT_H

#include <sys/ksynch.h>

/****************************************/
#include <linux/kernel.h>
#include <linux/slab.h>

struct __wait_queue {
	unsigned int flags;
#define WQ_FLAG_EXCLUSIVE	0x01
  //	struct task_struct * task;
  //	struct list_head task_list;
#if WAITQUEUE_DEBUG
	long __magic;
	long __waker;
#endif
};
typedef struct __wait_queue wait_queue_t;

static inline void init_waitqueue_head(wait_queue_head_t *q)
{

  /*
  q -> queue_mutex   = kmalloc(sizeof(kmutex_t),0);
  q -> queue_condvar = kmalloc(sizeof(kcondvar_t),0);
  */  
//do this later, mark this memory as a mutex and condition.
  //*********
  mutex_init(&(q -> queue_mutex),NULL,MUTEX_DRIVER,NULL);
  cv_init(&(q -> queue_condvar),NULL,CV_DRIVER,NULL);
  q -> initialized = TRUE;
  q -> numwaiting  = 0;
}
/****************************************/

#define DECLARE_WAIT_QUEUE_HEAD(name) wait_queue_head_t name = {initialized : FALSE} 
/***        wait_queue_head_t name = __WAIT_QUEUE_HEAD_INITIALIZER(name) ***/
#define DECLARE_WAITQUEUE(name,tsk) wait_queue_t name

#define __WAIT_QUEUE_HEAD_INITIALIZER(name) {initialized :FALSE}


static inline int waitqueue_active(wait_queue_head_t *q) 
{

  return (q -> numwaiting > 0);
} 



#endif
