/************************************/
/*instminor.h : This provides the   */
/*structures and functions needed to*/
/*mapping between instance and minor*/
/*numbers */
#include <linux/slab.h>

#ifndef _INST_MINOR
#define _INST_MINOR

#ifndef FAILURE
#define FAILURE -1
#endif

#ifndef SUCCESS
#define SUCCESS 1
#endif


typedef struct _inst_minor
{
  int instance_number;
  int minor_number;
  char *minor_name;
  struct _inst_minor *next;
  struct _inst_minor *prev;
}inst_minor;

int addInstMinor(int instance,int minor,char *name);
int remInstMinorByInstance(int instance);

inst_minor *getInstMinorByInstance(int instance);
inst_minor *getInstMinorByMinor(int minor);

int existsInstMinor(int instance_number,int minor_number);

int remInstMinorByMinor(int minor);
void remAllInstMinor();
//int getInstance(int minor);
int getMinor(int instance);

#endif
