/***************************************/
/*pits_block.h                         */
/*These are functions that deal with   */
/*the block driver nodes that linux    */
/*and Solaris employ.                  */
/***************************************/

#ifndef _PITS_BLOCK_
#define _PITS_BLOCK_

#include <misc/sunlinux.h>
#include <misc/globals.h>
#include <misc/sunlinuxfs.h>
#include <misc/pits_state.h>


#include <linux/fs.h>
#include <linux/interrupt.h>
//also want to define register_chrdev in the pits_char.c library file.

/*******************************/
/*cb_ops operations            */
/*******************************/
int pits_block_open(dev_t *devp,int flag,int otyp,cred_t *credp);
int pits_block_close(dev_t dev,int flag,int otyp,cred_t *credp);
int pits_block_read(dev_t dev,struct uio *uio_p,cred_t *credp);
int pits_block_write(dev_t dev,struct uio *uiop,cred_t *credp);
int pits_block_chpool(dev_t dev,short events,int anyyet,
			    short *reventsp,struct pollhead **phpp);

int pits_block_strategy(struct buf *bp);


int pits_block_ioctl(dev_t dev,int cmd, intptr_t arg, 
			   int mode, cred_t *credp, int *rvalp);

void initDefaultBdops(sun_linux_state *instance_state,
		      struct block_device_operations *bdops);
void finiDefaultBdops(sun_linux_state *instance_state);

struct block_device_operations *getBdops(kdev_t dev);

typedef struct buffer_head_queue_struct
{
  kmutex_t mutex;
  int running;
  int scheduled;
  int direction;
  struct buffer_head *head;
  struct tasklet_struct qtasklet;
}buffer_head_queue_t;

typedef struct pits_bh_queue_struct
{
  buffer_head_queue_t rqueue;
  buffer_head_queue_t wqueue;
}pits_bh_queue_t;

//pits_bh_queue_t pits_bh_queue;

int init_buffer_head_queue(pits_bh_queue_t *pqueue);

static void __enqueue_buffer_head(buffer_head_queue_t *queue,
				  struct buffer_head *bh);

static void enqueue_buffer_head(struct buffer_head *linux_bh,
				int direction);
static void pits_block_tasklet(unsigned long args);

#endif
