/***************************************/
/*pits_char.h                          */
/*These are functions that deal with   */
/*the character driver nodes that linux*/
/*and Solaris employ.                  */
/***************************************/

#ifndef _PITS_CHAR_
#define _PITS_CHAR_

#include <misc/sunlinux.h>
//#include <misc/globals.h>
#include <misc/pits_state.h>
#include <misc/sunlinuxfs.h>
#include <linux/fs.h>

//also want to define register_chrdev in the pits_char.c library file.

/*******************************/
/*cb_ops operations            */
/*******************************/
int pits_char_open(dev_t *devp,int flag,int otyp,cred_t *credp);
int pits_char_close(dev_t dev,int flag,int otyp,cred_t *credp);
int pits_char_read(dev_t dev,struct uio *uio_p,cred_t *credp);
int pits_char_write(dev_t dev,struct uio *uiop,cred_t *credp);
int pits_char_chpool(dev_t dev,short events,int anyyet,
			    short *reventsp,struct pollhead **phpp);

int pits_char_strategy(struct buf *bp);

int pits_char_ioctl(dev_t dev,int cmd, intptr_t arg, 
			   int mode, cred_t *credp, int *rvalp);

void initDefaultFops(sun_linux_state *instance_state,
			    struct file_operations *f_ops);
void finiDefaultFops(sun_linux_state *instance_state);



#endif
