#ifndef __PITS_INIT_H
#define __PITS_INIT_H

#include <sys/stat.h>
#include <sys/sunddi.h>


#define TASKLET_INIT  1
#define RESOURCE_INIT 2
#define BH_INIT       4
#define BLOCK_INIT    8
#define PAR_INIT      16
#define LINUX_INIT    32
#define PITS_INIT     64
 
int do_pits_init(dev_info_t *dip);
int do_pits_fini(dev_info_t *dip);

int init_tasklet_vectors(dev_info_t *dip);
int fini_tasklet_vectors(dev_info_t *dip);

int init_resources(dev_info_t *dip);
int fini_resources(dev_info_t *dip);

//int init_bh_vec(dev_info_t *dip);
//int fini_bh_vec(dev_info_t *dip);

int init_block_arrays(dev_info_t *dip);
int fini_block_arrays(dev_info_t *dip);

int init_linux_parameters(dev_info_t *dip);

int set_initialized(dev_info_t *dip,int val);
int unset_initialized(dev_info_t *dip,int val);
int get_initialized(dev_info_t *dip);

int linux_init_module(void);
void linux_cleanup_module(void);



#endif
