#ifndef _PITS_MUTEX_
#define _PITS_MUTEX_

#include <sys/ksynch.h>
#include <misc/config.h>
typedef struct pits_mutex_struct
{
  kmutex_t mutex;
  uint8_t locked;
  kcondvar_t cv_wait;
  int initialized;

  char *name;
  kmutex_type_t type;
  void *arg;
}pits_mutex_t;


void pits_mutex_init(pits_mutex_t *mp,
		     char *name, 
		     kmutex_type_t type,
		     void *arg);

void pits_mutex_destroy(pits_mutex_t *mp);

void pits_mutex_enter(pits_mutex_t *mp);

int pits_mutex_owned(pits_mutex_t *mp);

int pits_mutex_tryenter(pits_mutex_t *mp);

#endif
