#ifndef __PITS_STATE_
#define __PITS_STATE_



#include <misc/sunlinux.h>
#include <misc/pits_param.h>

#include <asm/ptrace.h> /*for pt_regs */

#ifndef _LINUX_REQUEST_QUEUE
#define _LINUX_REQUEST_QUEUE
struct request_queue;
typedef struct request_queue request_queue_t;
#endif


#include <linux/blkdev.h> /*for request_queue*/

//struct request_queue;
//typedef struct request_queue request_queue_t;

struct linux_irq_t
{
  /*interrupt stuff*/
  unsigned int irq;
  int initialized;
  kcondvar_t fini_wait;
  int fini_detected;
  int enable_count;
  uint32_t count;
  int interrupting;
  ddi_iblock_cookie_t iblock_cookie;
  kmutex_t mutex;
  void (*handler)(int, void *, struct pt_regs *);
  void *dev_id;
  struct pt_regs *ipt_regs;
};

typedef struct sun_linux_drv_state 
{ 
  char *cname; 
  char *bname;
  dev_info_t *dip; 
  int pits_major;
  int linux_major;
  int minornumber; 
  char *minorname; 
  int instance; 
  int spec_type; 
  int open_type; 
  char *node_type; 
  int initialized;
  kmutex_t mutex; 
  kcondvar_t condvar; 
  struct pollhead phead; 

  /*hardware interrupt structure*/
  //struct linux_irq_t linux_irq;

  /*linux function pointers*/ 
  struct file_operations *fops;
  struct block_device_operations *bdops;
  //  linux_inode *open_inode; 
  //linux_file  *open_file; 
  //int is_open; 
  int num_open;
  int open;
  int nlayered;

  kmutex_t blist_mutex;
  kcondvar_t blist_cv;
  struct buf *blist;

  struct buffer_head *block_linux_bh;
  struct request *block_req;

  //kmem_cache_t *bh_cache;
  //kmem_cache_t *req_cache;
  int block_start_running;
  int block_start_scheduled;
  int bh_running;

  struct diskhd *blist_dp;
  void *block_dma_buf;
  unsigned int npar;
  PITS_parameter *par;

  //default request queue for device. (see linux/blkdev.h).
  //struct request_queue blk_default_queue;
  request_queue_t *blk_default_queue;

  struct pci_dev *linux_pci_device;

}sun_linux_state; 

void *getSunStateP();

//static void *sun_state=NULL; //look in sunlinux.c

#define getInstanceByNum(num,instance_state)                        \
({ int __ret = DDI_SUCCESS;                                         \
  int instance = num;                                               \
  if (getSunStateP() == NULL || instance < 0) {__ret = ENXIO;}      \
  else                                                              \
    {                                                               \
      instance_state = ddi_get_soft_state(getSunStateP(),instance); \
      if (instance_state == NULL) __ret=ENXIO;                      \
    }                                                               \
                                                                    \
  __ret;                                                            \
})

#define getInstance(dip,instance_state)                                \
({  int __ret =DDI_SUCCESS;                                            \
    int instance = -1;                                                 \
    instance_state = NULL;                                             \
    if (dip == NULL || getSunStateP() == NULL) {__ret = ENXIO;}         \
    else                                                               \
    {                                                                  \
       instance = ddi_get_instance(dip);                               \
       if (instance < 0){__ret = ENXIO;}                               \
       else                                                            \
       {                                                               \
           instance_state = ddi_get_soft_state(getSunStateP(),instance);\
           if (instance_state == NULL) __ret=ENXIO;                    \
       }                                                               \
    }                                                                  \
    __ret;                                                             \
})


#define getInstanceFReturn(dip,instance_state) \
    { \
      int ret = getInstance(dip,instance_state); \
      if (ret != DDI_SUCCESS) return ret;  \
    }



#endif
