/**************************************/
/*sunlinux.h                          */
/*Barry Henrichs                      */
/*Sean McIlwain                       */
/*CS736 - Advanced Operating Systems  */
/*Spring '2003                        */
/*Final Project                       */
/**************************************/



#ifndef _SUNLINUX

#define _SUNLINUX
#include <sys/conf.h> 
#include <sys/devops.h> 
#include <sys/ddi.h> 
#include <sys/sunddi.h> 
#include <sys/modctl.h> 
#include <sys/stat.h> 
#include <sys/kmem.h>



#include <sys/cmn_err.h>
/*this is for logging */ 
/*
#include <linux/fs.h>
*/


/*some basic definitions to make boolean code more readable*/
#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif


typedef struct file linux_file; 
typedef struct inode linux_inode;
typedef struct file_operations linux_fops;


#ifndef SEEK_SET
#define SEEK_SET 0
#endif
#ifndef SEEK_CUR
#define SEEK_CUR 1
#endif
#ifndef SEEK_END
#define SEEK_END 2
#endif


#define returnPanicValue(pos,ret)            \
   if (getGlobal() -> panic == TRUE) {   \
       printk("%s:Linux panic called..\n",pos); \
       return ret;                       \
      }                                  

#define returnPanic(pos)   \
   if (getGlobal() -> panic == TRUE) {   \
       printk("%s:Linux panic called..\n",pos); \
       return ret;                       \
      }                                  


#ifdef PITS_DEBUG
#define DEBUGCMD(x) x;
#define DEBUGDMESG(x) printk(x);
#define DEBUGDMESG2(x,y) printk(x,y); 
#define DEBUGDMESG3(x,y,z) printk(x,y,z);
#define DEBUGDMESG4(w,x,y,z) printk(w,x,y,z);
#else
#define DEBUGCMD(x) ;
#define DEBUGDMESG(x) ;
#define DEBUGDMESG2(x,y) ;
#define DEBUGDMESG3(x,y,z);
#define DEBUGDMESG4(w,x,y,z);
#endif

#endif
