/**************************************/
/*sunlinuxdrv.h                       */
/*Barry Henrichs                      */
/*Sean McIlwain                       */
/*CS736 - Advanced Operating Systems  */
/*Spring '2003                        */
/*Final Project                       */
/**************************************/


#ifndef _SUNLINUX_DRV_
#define _SUNLINUX_DRV_

#include <misc/sunlinux.h>
#include <misc/pits_state.h>
#include <misc/globals.h>
#include <misc/sunlinuxfs.h>
#include <linux/fs.h>


/*Definitions*/


 


/*************/
/*Structures */
/*************/
static struct modldrv sun_modldrv;
static struct cb_ops sun_cb_ops;
static struct dev_ops sun_dev_ops;




/*****************************/ 
/*dev_ops functions          */ 
/*****************************/ 
static int sun_getinfo(dev_info_t *dip,ddi_info_cmd_t infocmd, void *arg, void **result); 
static int sun_probe(dev_info_t *dip); 
static int sun_attach(dev_info_t *dip, ddi_attach_cmd_t cmd); 
static int sun_detach(dev_info_t *dip,ddi_detach_cmd_t cmd); 

/*****************************/
/*cb_ops operations          */
/*****************************/
static int sun_open(dev_t *devp,int flag,int otyp,cred_t *credp);
static int sun_close(dev_t dev,int flag,int otyp,cred_t *credp);
static int sun_read(dev_t dev,struct uio *uio_p,cred_t *credp);
static int sun_write(dev_t dev,struct uio *uiop, cred_t *credp);
static int sun_chpoll(dev_t dev,short events,int anyyet,
		      short *reventsp,struct pollhead **phpp);
static int pits_strategy(struct buf *bp);


static int sun_ioctl(dev_t dev, int cmd, intptr_t arg, int mode,cred_t *credp, int *rvalp);
/*****************************/
/*fops stuff                 */
/*****************************/
//static void initDefaultFops(struct file_operations *); 
//static void deleteDefaultFops(); 


/****************************/
/*other functions           */
/****************************/
//static u_int sun_pollwakeup(sun_linux_state *instance,short event);

static struct modlinkage sun_linkage = 
{ 
  MODREV_1, 
  &sun_modldrv,
  NULL 
};  


static struct modldrv sun_modldrv =   
{  
  &mod_driverops,                          /* drv_modops   */  
  "Sun Linux driver v0.00",                /* drv_linkinfo */  
  &sun_dev_ops                             /* drv_dev_ops  */  
};  

static struct dev_ops sun_dev_ops =  
{  
  DEVO_REV,        /* devo_rev */  
  0,               /* devo_refcnt */  
  sun_getinfo,     /* getinfo     */  
  nulldev,         /* indentify   */  
  nulldev,         /* probe       */  
  sun_attach,      /* attach      */  
  sun_detach,      /* detach      */  
  nodev,           /* devo_reset  */  
  &sun_cb_ops,     /* devo_cb_ops */  
  (struct bus_ops *)NULL,            /* devo_bus_ops*/  
  nulldev          /* power       */  
};  



 
/*define a structure for the device drivers.*/ 
static struct cb_ops sun_cb_ops = 
{ 
  sun_open,  /*open */ 
  sun_close, /*close */ 
  pits_strategy, /*strategy*/ 
  nodev,    /*print*/ 
  nodev, /*dump*/ 
  sun_read, /*read*/ 
  sun_write, /*write*/ 
  sun_ioctl, /*ioctl*/ 
  nodev, /*devmap*/ 
  nodev, /*mmap*/ 
  nodev, /*segmap*/ 
  sun_chpoll, /*chpoll*/ 
  ddi_prop_op, /*prop_op*/ 
  NULL,  /* streamtab - for streams (network) drivers */ 
  D_MP,   /*cb_flag D_MP means thread safe */ 
  CB_REV,  /*structure revision number*/ 
  nodev, 
  nodev 
}; 

 
 





#endif
