//#include <misc/sunlinux.h>


#ifndef _SUNLINUXFS
#define _SUNLINUXFS

#include <linux/fs.h>
#include <linux/kernel.h> /*MINORBITS*/
#include <asm/fcntl.h>


/*from sun's /sys/file.h*/
#define FREAD 0x01
#define FWRITE 0x02

/*from sun's /sys/fcntl.h*/
#define sun_O_NDELAY 0x04
#define sun_O_NONBLOCK 0x80

/*from linux's /asm/fcntl.h*/
#define O_ACCMODE          0003
#define O_RDONLY             00
#define O_WRONLY             01
#define O_RDWR               02


/******************************************/
/*FUNCTION and PROCEDURE Prototypes       */
/******************************************/
linux_file *createOpenFileS(linux_fops *fops,linux_inode *inode,
			    int sun_flags,int otype);
linux_file *createOpenFile(linux_fops *fops,linux_inode *inode,
			   int sun_flags,int otype);

int checkLinuxFile(linux_file *file);
void destroyOpenFile(linux_file *open_file);
void destroyOpenInode(linux_inode *open_inode);
void setLinuxFileFlags(linux_file *filep,int sunflags);
int make_i_rdev(int major,int minor);

linux_inode *createOpenInodeS(major_t smajor,minor_t sminor);
linux_inode *createOpenInode(major_t lmajor,minor_t lminor);

int addOpenInode(linux_inode *inode);
int addOpenFile(linux_file *file);

linux_inode *getOpenInodeS(major_t smajor,minor_t sminor);
linux_inode *getOpenInode(major_t lmajor,minor_t lminor);

linux_file *getOpenFileS(major_t smajor,minor_t sminor);
linux_file *getOpenFile(major_t lmajor,minor_t lminor);

void removeOpenInode(linux_inode *inode);
void removeOpenFile(linux_file *file);


#endif
