/*
 *  linux/mm/page_alloc.c
 *
 *  Copyright (C) 1991, 1992, 1993, 1994  Linus Torvalds
 *  Swap reorganised 29.12.95, Stephen Tweedie
 *  Support of BIGMEM added by Gerhard Wichert, Siemens AG, July 1999
 *  Reshaped it to be a zoned allocator, Ingo Molnar, Red Hat, 1999
 *  Discontiguous memory support, Kanoj Sarcar, SGI, Nov 1999
 *  Zone balancing, Kanoj Sarcar, SGI, Jan 2000
 */

#include <linux/config.h>
#include <linux/mm.h>
#include <linux/swap.h>
//#include <linux/swapctl.h>
#include <linux/interrupt.h>
//#include <linux/pagemap.h>
//#include <linux/bootmem.h>
#include <linux/slab.h>
//#include <linux/compiler.h>


/*
 * Common helper functions.
 */
unsigned long __get_free_pages(unsigned int gfp_mask, unsigned int order)
{
  unsigned long size = (1 << order) * PAGE_SIZE;
  void *ptr = kmalloc(size,gfp_mask);
  return (unsigned long)ptr;
}

void __free_pages(struct page *page, unsigned int order)
{
  DEBUGDMESG("Inside __free_pages (page)");
  DEBUGDMESG("Dunno where this is being called from...");
  ;
}

void free_pages(unsigned long addr, unsigned int order)
{
  DEBUGDMESG("Okay, free the pages");

  kfree((void*)addr);
}

