#include <linux/fs.h>
#include <linux/blkdev.h>
#include <linux/blkpg.h>


/**************************************************************/
/*blk_ioctl() : execute the generic ctl functions for block   */
/*devices.                                                    */
/*Probably just a copy of blkpg.c                             */
/*in drivers/block/blkpg.c                                    */
/**************************************************************/
int blk_ioctl(kdev_t dev, unsigned int cmd, unsigned long arg)
{
  printk("inside blk_ioctl\n");
  //struct gendisk *g;
  //u64 ullval = 0;
  int intval;
  
  if (!dev)
    return -EINVAL;
  
  printk("blk_ioctl(): major %d minor %d cmd %d is ",getmajor(dev),getminor(dev),cmd);
  switch (cmd) 
    {
    case BLKROSET:
      printk("BLKROSET\n");
      /*
      if (!capable(CAP_SYS_ADMIN))
	return -EACCES;
      if (get_user(intval, (int *)(arg)))
	return -EFAULT;
      set_device_ro(dev, intval);
      */
      return 0;
    case BLKROGET:
      printk("BLKROGET\n");
      /*
      intval = (is_read_only(dev) != 0);
      return put_user(intval, (int *)(arg));
      */
      return 0;
    case BLKRASET:
      printk("BLKRASET\n");
      /*
      if(!capable(CAP_SYS_ADMIN))
	return -EACCES;
      if(arg > 0xff)
	return -EINVAL;
      */
      read_ahead[MAJOR(dev)] = arg;
      return 0;
    case BLKRAGET:
      printk("BLKRAGET\n");
      /*
      if (!arg)
	return -EINVAL;
      return put_user(read_ahead[MAJOR(dev)], (long *) arg);
      */
      return 0;
    case BLKFLSBUF:
      printk("BLKFLSBUF\n");
      /*
      if(!capable(CAP_SYS_ADMIN))
	return -EACCES;
      fsync_dev(dev);
      invalidate_buffers(dev);
      */
      return 0;

    case BLKSSZGET:
      printk("BLKSSZGET\n");
      /* get block device sector size as needed e.g. by fdisk */
      //intval = get_hardsect_size(dev);
      //return put_user(intval, (int *) arg);
      return 0;
    case BLKGETSIZE:
      printk("BLKGETSIZE:not 64\n");
    case BLKGETSIZE64:
      printk("BLKGETSIZE\n");
      //g = get_gendisk(dev);
      //if (g)
      //ullval = g->part[MINOR(dev)].nr_sects;
      /*
      if (cmd == BLKGETSIZE)
	return put_user((unsigned long)ullval, (unsigned long *)arg);
      else
	return put_user(ullval << 9, (u64 *)arg);
      */
      return 0; 
	//#if 0
    case BLKRRPART: /* Re-read partition tables */
      printk("BLKRRPART\n");
      //if (!capable(CAP_SYS_ADMIN)) 
      //return -EACCES;
      //return reread_partitions(dev, 1);
      return 0;
      //#endif

    case BLKPG:
      printk("BLKPG\n");
      return 0;
      //return blkpg_ioctl(dev, (struct blkpg_ioctl_arg *) arg);
			
    case BLKELVGET:
      printk("BLKELVGET\n");
      return 0;
      //return blkelvget_ioctl(&blk_get_queue(dev)->elevator,
      //(blkelv_ioctl_arg_t *) arg);
    case BLKELVSET:
      printk("BLKELVSET\n");
      return 0;
      //return blkelvset_ioctl(&blk_get_queue(dev)->elevator,
      //			     (blkelv_ioctl_arg_t *) arg);
      
    case BLKBSZGET:
      /* get the logical block size (cf. BLKSSZGET) */
      printk("BLKBSZGET\n");
      intval = BLOCK_SIZE;
      if (blksize_size[MAJOR(dev)])
	intval = blksize_size[MAJOR(dev)][MINOR(dev)];
      //return put_user (intval, (int *) arg);
      return 0;
    case BLKBSZSET:
      /* set the logical block size */
      printk("BLKSZSET\n");
      /*
      if (!capable (CAP_SYS_ADMIN))
	return -EACCES;
      if (!dev || !arg)
	return -EINVAL;
      if (get_user (intval, (int *) arg))
	return -EFAULT;
      if (intval > PAGE_SIZE || intval < 512 ||
	  (intval & (intval - 1)))
	return -EINVAL;
      */
      /*
      if (is_mounted (dev) || is_swap_partition (dev))
	return -EBUSY;
      */
      //set_blocksize (dev, intval);
      return 0;

    default:
      printk("unknown blk_ioctl\n");
      return -EINVAL;
    }


  return (0);
}
