#include <misc/sunlinux.h>
#include <misc/pits_init.h>
#include <misc/pits_param.h>
//#include <misc/sunlinuxdrv.h>
#include <misc/globals.h>
#include <misc/pits_state.h>


/***********************************************/
/*do_pits_init() : initializes the linux kernel*/
/*emulation stuff and the kernel module for the*/
/*instance described in dip.                   */
/***********************************************/
int do_pits_init(dev_info_t *dip)
{
  int ret;
  ret = init_resources(dip);
  if (ret != DDI_SUCCESS)
    {
      printk("error init_resources %d\n",ret);
      return ret;
    }
  /*
  ret = init_bh_vec(dip);
  if (ret != DDI_SUCCESS)
    {
      printk("error init_bh_vec %d\n",ret);
      return ret;
    }
  */
  ret = init_block_arrays(dip);
  if (ret != DDI_SUCCESS)
    {
      printk("error init_block_arrays %d\n",ret);
      return (ret);
    }
  
  
  ret = init_linux_parameters(dip);
  if (ret != DDI_SUCCESS)
    {
      printk("error init_linux_parameters %d\n",ret);
      return (ret);
    }
  
  
  ret = set_linux_parameters(dip);
  
  if (ret != DDI_SUCCESS)
    {
      printk("error set_linux_parameters %d\n",ret);
      return (ret);
    }
  ret = set_initialized(dip,PAR_INIT);
  if (ret != DDI_SUCCESS)
    {
      printk("error set_init parinit %d\n",ret);
    }


  ret = linux_init_module();
  if (ret != DDI_SUCCESS)
    {
      printk("Error linux_init_module() %d\n",ret);
      return ret;
    }
  
  ret = set_initialized(dip,LINUX_INIT);
  if (ret != DDI_SUCCESS)
    {
      printk("error set_init LINUX_INIT %d\n",ret);
      return ret;
    }
  ret = set_initialized(dip,PITS_INIT);
  
  if (ret != DDI_SUCCESS)
    {
      printk("error set_init PITS_INIT %d\n",ret);
    }
  
  return ret;

}

int do_pits_fini(dev_info_t *dip)
{
  int ret =0;
  sun_linux_state *instance_state;

  getInstanceFReturn(dip,instance_state);

  
  if (instance_state -> initialized & LINUX_INIT)
    {
      printk("calling linux_cleanup\n");
      linux_cleanup_module();
      unset_initialized(dip,LINUX_INIT);
    }
  /*
  if (instance_state -> linux_irq.initialized == TRUE)
    {
      printk("irq still assigned, attempting to remove it...\n");
      free_irq((instance_state -> linux_irq).irq,
	       (instance_state -> linux_irq).dev_id);
    }
  */
  fini_block_arrays(dip);
  //fini_bh_vec(dip);
  fini_resources(dip);
  
  ret = unset_initialized(dip,PITS_INIT);
  
  
  return ret;

}
int unset_initialized(dev_info_t *dip,int val)
{
  sun_linux_state *instance_state = NULL;
  
  getInstanceFReturn(dip,instance_state);
  
  instance_state -> initialized = instance_state -> initialized & ~val;
  
  return (DDI_SUCCESS);
}
int set_initialized(dev_info_t *dip,int val)
{
  sun_linux_state *instance_state = NULL;
  
  getInstanceFReturn(dip,instance_state);
  
  instance_state -> initialized = instance_state -> initialized | val;

  return DDI_SUCCESS;
				      
}

int get_initialized(dev_info_t *dip)
{
  sun_linux_state *instance_state = NULL;

  getInstance(dip,instance_state);

  if (instance_state == NULL) {return 0;}

  return (instance_state -> initialized);
}




