#include <linux/pci.h>
#include <misc/pits_state.h>
/************************/
/*from linux/pci.h      */
/************************/
const struct pci_device_id *
pci_match_device(const struct pci_device_id *ids, const struct pci_dev *dev)
{
  printk("pci_match_device() : NULL fxn!\n");
  return NULL;
}



void pci_set_master(struct pci_dev *dev)
{
  DEBUGDMESG("Inside pci_set_master\n");
  printk("pci_set_master() : NULL fxn!\n");
  DEBUGDMESG("Done pci_set_master\n");
  ;
}
/*
int pci_set_dma_mask(struct pci_dev *dev,u64 mask)
{
  DEBUGDMESG("Inside pci_set_dma_mask\n");
  printk("pci_set_dma_mask() : NULL fxn!\n");
  DEBUGDMESG("Done pci_set_dma_mask\n");
  return 0;
}
*/

int pci_read_config_byte(struct pci_dev *dev, int where, u8 *val)
{
  //DEBUGDMESG("Inside pci_read_config_byte\n");
  *val = (u8)pci_config_get8(dev -> config_handle,(off_t)where);
  //DEBUGDMESG("Done pci_read_config_byte\n");
  return 0;
}
int pci_read_config_word(struct pci_dev *dev, int where, u16 *val)
{
  //DEBUGDMESG("Inside pci_read_config_word\n");
  *val = (u16)pci_config_get16(dev -> config_handle,(off_t)where);
  //DEBUGDMESG("Done pci_read_config_word\n");
  return 0;
}
int pci_read_config_dword(struct pci_dev *dev, int where, u32 *val)
{
  //DEBUGDMESG("Inside pci_read_config_dword\n");
  *val = (u32)pci_config_get32(dev -> config_handle,(off_t)where);
  //DEBUGDMESG("Done pci_read_config_dword\n");
  return 0;
}
int pci_write_config_byte(struct pci_dev *dev, int where, u8 val)
{
  //DEBUGDMESG("Inside pci_write_config_byte\n");
  pci_config_put8(dev -> config_handle,(off_t)where,val);
  //DEBUGDMESG("Done pci_write_config_byte\n");
  return 0;
}
int pci_write_config_word(struct pci_dev *dev, int where, u16 val)
{
  //DEBUGDMESG("Inside pci_write_config_word\n");
  pci_config_put16(dev -> config_handle,(off_t)where,val);
  //DEBUGDMESG("Done pci_write_config_word\n");
  return 0;
}
int pci_write_config_dword(struct pci_dev *dev, int where, u32 val)
{
  //DEBUGDMESG("Inside pci_write_config_dword\n");
  pci_config_put32(dev -> config_handle,(off_t)where,val);
  //DEBUGDMESG("Done pci_write_config_dword\n");
  return 0;
}

int pci_enable_device(struct pci_dev *dev)
{
  DEBUGDMESG("Inside pci_enable_device\n");
  printk("pci_enable_device() : NULL fxn!\n");
  DEBUGDMESG("Done pci_enable_device\n");
  return 0;
}

/*Power Management related routines*/
int pci_set_power_state(struct pci_dev *dev, int state)
{
  DEBUGDMESG("Inside pci_set_power_state\n");
  printk("pci_set_power_state() : NULL fxn!\n");
  DEBUGDMESG("done pci_set_power_state\n");
  return 0;
}

/* New-style probing supporting hot-pluggable devices */
int pci_register_driver(struct pci_driver *driver)
{
  sun_linux_state *instance_state;
  int ret;

  DEBUGDMESG("Inside pci_register_driver\n");

  if (getInstanceByNum(0,instance_state) != DDI_SUCCESS)
    {
      printk("cant find instance\n");
      return -1;
    }
  if (driver -> probe && instance_state -> linux_pci_device)
    {
      ret = driver -> probe(instance_state -> linux_pci_device,0);
    }
  else
    {
      printk("driver doesn't have probe fxn or linux_pci_device is null!\n");
      ret = -1;
    }
  if (ret >= 0) {instance_state -> linux_pci_device -> driver = driver;}

		      
  DEBUGDMESG2("Done pci_register_driver %d\n",ret);
  
  return ret;
  ;
}
void pci_unregister_driver(struct pci_driver *driver)
{
  sun_linux_state *instance_state;
  // int ret;

  DEBUGDMESG("Inside pci_unregister_driver\n");

  if (getInstanceByNum(0,instance_state) != DDI_SUCCESS)
    {
      printk("cant find instance\n");
      return;
    }
  if (instance_state -> linux_pci_device && instance_state -> linux_pci_device -> driver)
    {
      if (instance_state -> linux_pci_device -> driver == driver)
	{
	  if (driver -> remove)
	    {
	      driver -> remove(instance_state -> linux_pci_device);
	    }
	  instance_state -> linux_pci_device -> driver = NULL;
	}
    }
  

  DEBUGDMESG("Done pci_unregister_driver\n");
  ;
}

int pci_module_init(struct pci_driver *drv)
{
  int rc;
  
  DEBUGDMESG("inside pci_module_init\n");
  rc = pci_register_driver(drv);

  if (rc >= 0)
    {
      DEBUGDMESG("done pci_module_init\n");
      return 0;
    }
  else
    {
      DEBUGDMESG2("done pci_module_init (error) %d\n",rc);
      return -ENODEV;
    }
}

