#include <linux/notifier.h>
#include <linux/kernel.h>


/*From /linux/kernel/sys.c*/
/**
 *	register_reboot_notifier - Register function to be called at reboot time
 *	@nb: Info about notifier function to be called
 *
 *	Registers a function with the list of functions
 *	to be called at reboot time.
 *
 *	Currently always returns zero, as notifier_chain_register
 *	always returns zero.
 */
 
int register_reboot_notifier(struct notifier_block * nb)
{
  DEBUGDMESG("inside register_reboot_notifier");
  //return notifier_chain_register(&reboot_notifier_list, nb);
  printk("register_reboot_notifier():NULL fxn!\n");
  DEBUGDMESG("done register_reboot_notifier");
  return 0;
}

/**
 *	unregister_reboot_notifier - Unregister previously registered reboot notifier
 *	@nb: Hook to be unregistered
 *
 *	Unregisters a previously registered reboot
 *	notifier function.
 *
 *	Returns zero on success, or %-ENOENT on failure.
 */
 
int unregister_reboot_notifier(struct notifier_block * nb)
{
  DEBUGDMESG("inside unregister_reboot_notifier");

  //return notifier_chain_unregister(&reboot_notifier_list, nb);
  printk("unregister_reboot_notifier(): NULL fxn!\n");
  DEBUGDMESG("done unregister_reboot_notifier");
  return 0;
}
