#include <asm/processor.h>
//From linux/arch/i386/kernel/process.c
#include <sys/proc.h>

/*
 * Create a kernel thread
 */



void pits_thread_handler(void *arg);

typedef int (linux_fn) (void *);

struct pits_thread
{
  kmutex_t mutex;
  kthread_t *threadp;
  linux_fn *fn;
  void *arg;
};


void pits_thread_handler(void *arg)
{

  struct pits_thread *pit_thread = (struct pits_thread *)arg;
  printk("inside pits_thread_handler\n");
  mutex_enter(&(pit_thread -> mutex)); 
  current -> is_thread = TRUE;
  current -> threadp   = pit_thread -> threadp;
  printk("calling linux fxn\n");
  mutex_exit(&(pit_thread -> mutex));
  pit_thread -> fn(pit_thread -> arg);
  printk("freeing thread\n");
  kfree(pit_thread);
  
}


/* It is hard to find documentation online about kernel threads in
 * Solaris.  Maybe the Solaris Internal's book has some insight.
 */
int kernel_thread(int (*fn)(void *), void * arg, unsigned long flags)
{
  kthread_t *t=NULL;
  int priority = 10;
  struct pits_thread *thread = kmalloc(sizeof(struct pits_thread),0);

  thread -> fn = fn;
  thread -> arg = arg;
  printk("inside kernel thread...\n");
  printk("calling solaris thread_create\n");

  mutex_init(&(thread -> mutex),NULL,MUTEX_DRIVER,NULL);
  mutex_enter (&(thread -> mutex));

  t = thread_create(NULL,         /* stack?    */
		    DEFAULTSTKSZ, /* stacksize */
		    pits_thread_handler,/* function  */
		    (caddr_t)thread, /* function arguments */
		    0,            /* len? */
		    &p0,          /* process */
		    TS_RUN,       /* state   */
		    priority      /* priority*/
		    );

  if (t== NULL) 
    {
      printk("warning thread not created!\n");
      kfree(thread);
    }
  thread -> threadp = t;

  mutex_exit(&(thread -> mutex));

  return t == NULL;
}




/*
 * Free current thread data structures etc..
 */
void exit_thread(void)
{
  printk("inside exit_thread\n");
  printk("exit_thread() : NULL fxn!\n");
  /* nothing to do ... */
}

void flush_thread(void)
{
  printk("flush_thread() : NULL fxn!\n");
  /*
	struct task_struct *tsk = current;

	memset(tsk->thread.debugreg, 0, sizeof(unsigned long)*8);
	//	 * Forget coprocessor state..
	 
	clear_fpu(tsk);
	tsk->used_math = 0;
*/
  ;
}

void release_thread(struct task_struct *dead_task)
{
  printk("release_thread() : NULL fxn!\n");
  /*
	if (dead_task->mm) {
		void * ldt = dead_task->mm->context.segments;

		// temporary debugging check
		if (ldt) {
			printk("WARNING: dead process %8s still has LDT? <%p>\n",
					dead_task->comm, ldt);
			BUG();
		}
	}

	release_x86_irqs(dead_task);
  */

  ;
}
