#include <linux/sched.h>
#include <linux/completion.h>
#include <linux/kernel.h>

void interruptible_sleep_on(wait_queue_head_t *q)
{
  wait_queue_head_t *t = q;
  int __ret = 1;
  //printk("inside interruptible_sleep_on");
  
  if (t -> initialized == FALSE) { init_waitqueue_head(t);}
  
  mutex_enter(&(t -> queue_mutex));
  //printk("entering loop");
  //while(__ret != 0)
  //  {
  t -> numwaiting++;
  __ret = cv_wait_sig(&(t -> queue_condvar),&(t -> queue_mutex));
  //DEBUGCMD(printk("__ret %d",__ret));
  //  }
  //printk("exiting mutex");
  t -> numwaiting --;

  if (__ret == 0) {current -> sigpending = 1;}

  mutex_exit(&(t -> queue_mutex));
  
  //printk("done interruptible_sleep_on");
}

long interruptible_sleep_on_timeout(wait_queue_head_t *q,signed long timeout)
{
  wait_queue_head_t *t = q;
  int __ret = 1;
  //printk("inside interruptible_sleep_on_timeout");
  
  if (t -> initialized == FALSE) { init_waitqueue_head(t);}
  
  mutex_enter(&(t -> queue_mutex));
  //printk("entering loop");
  //while(__ret != 0)
  //  {
  t -> numwaiting++;
  __ret = cv_timedwait_sig(&(t -> queue_condvar),&(t -> queue_mutex),(clock_t)timeout+ddi_get_lbolt());
  //printk("__ret %d",__ret);
  //  }
  //printk("exiting mutex");
  t -> numwaiting --;

  if (__ret == 0) {current -> sigpending = 1;}

  mutex_exit(&(t -> queue_mutex));
  
  //printk("done interruptible_sleep_ontimeout");

  return(__ret);

}

signed long schedule_timeout(signed long timeout)
{
  delay(timeout);
  return 0;
}

void __wake_up(wait_queue_head_t *q, unsigned int mode, int nr)
{
  //DEBUGCMD(printk("__wake_up() : calling wake_up_interruptible\n"));
  //printk("__wake_up():NULL fxn!\n");
  //this needs to be fixed..
  wake_up_interruptible(q);
}
void daemonize(void)
{
  DEBUGCMD(printk("daemonize(): NULL fxn!\n"));
  ;
}

int kill_proc(pid_t pid,int s,int n)
{
  DEBUGCMD(printk("kill_proc():NULL fxn!\n"));
  return 0;
}

int send_sig(int sig, struct task_struct *t, int pri)
{
  int ret =0;
  proc_t *p = NULL;
  
  DEBUGCMD(printk("inside send_sig %d\n",sig));

  DEBUGCMD(
  if (t -> is_thread) 
    {
      printk("sending signal to thread\n");
    }
  );
  mutex_enter(&(t -> mutex));
  t -> sigpending = sig;
  if (t -> cv_wait)
    {
      cv_signal(t -> cv_wait);
    }
  else
    {
      printk("send_sig() : warning NULL cv!\n");
    }
  mutex_exit(&(t -> mutex));

  return ret;
}

void add_wait_queue(wait_queue_head_t *q, wait_queue_t *wait)
{
  DEBUGCMD(printk("add_wait_queue():NULL fxn!\n"));
}

void add_wait_queue_exclusive(wait_queue_head_t *q, wait_queue_t *wait)
{
  DEBUGCMD(printk("add_wait_queue_exclusive():NULL fxn!\n"));
}
void remove_wait_queue(wait_queue_head_t *q, wait_queue_t *wait)
{
  DEBUGCMD(printk("remove_wait_queue():NULL fxn!\n"));
}

void wait_for_completion(struct completion *x)
{
  wait_queue_head_t *t = &x -> wait;
  
  //printk("inside wait_for_completion\n");
  if (t -> initialized == FALSE) {init_waitqueue_head(t);} 

  //printk("waiting for completion done %d:\n",x -> done);
  mutex_enter(&(t -> queue_mutex));                                
  //printk("entering completion condition");                                 
  while(x -> done <= 0)                               
    {                                                             
      t -> numwaiting++;                                         
      cv_wait(&(t -> queue_condvar),&(t -> queue_mutex));  
      t -> numwaiting--;
    }                                                             
  //DEBUGCMD(printk("exiting completion condition\n"));
  x -> done --;
  mutex_exit(&(t -> queue_mutex));                                 
}

void complete(struct completion *x)
{
  wait_queue_head_t *t = &x -> wait;
  
  //printk("inside complete\n");

  if (t -> initialized == FALSE) {init_waitqueue_head(t);} 

  mutex_enter(&((t) -> queue_mutex));
  x -> done ++;

  cv_broadcast(&((t) -> queue_condvar));
  mutex_exit(&((t) -> queue_mutex));


  ;
}
void complete_and_exit(struct completion *x,long error_code)
{
  DEBUGCMD(printk("complete_and_exit():Just calling complete\n"));
  printk("complete_and_exit():error code is %l\n",error_code);
  complete(x);
  
}

void schedule(void)
{
  printk("inside schedule...\n");
  delay(1);
}



