#include <linux/types.h>


#include <sys/types.h> 


/*string.h*/ 
void *memset(void *s, int c, size_t count) 
{ 
   
   
  char *xs = (char *)s; 
   
  while (count--) 
    { 
      *xs++ = c; 
    } 
   
  return(s); 
} 
 
void *memcpy(void *dest,void *src,size_t count) 
{ 
  char *tmp,*s;

  if (dest == NULL)
    {
      printk("warning dest is null\n");
      return NULL;
    }
  if (src == NULL)
    {
      printk("warning src is null\n");
      return dest;
    }

  tmp = (char*)dest;
  s = (char*)src;

  while (count--) 
    *tmp++ = *s++; 
   
  return dest; 
   
} 

/*code in /linux/lib/string.c*/

/**
* strpbrk - Find the first occurrence of a set of characters
* @cs: The string to be searched
* @ct: The characters to search for
*/
char * strpbrk(const char * cs,const char * ct)
{
  const char *sc1,*sc2;

  for( sc1 = cs; *sc1 != '\0'; ++sc1) {
    for( sc2 = ct; *sc2 != '\0'; ++sc2) {
      if (*sc1 == *sc2)
	return (char *) sc1;
    }
  }
  return NULL;
}


/**
 * strtok - Split a string into tokens
 * @s: The string to be searched
 * @ct: The characters to search for
 *
 * WARNING: strtok is deprecated, use strsep instead.
 */
char * ___strtok;
char * strtok(char * s,const char * ct)
{
	char *sbegin, *send;

	sbegin  = s ? s : ___strtok;
	if (!sbegin) {
		return NULL;
	}
	sbegin += strspn(sbegin,ct);
	if (*sbegin == '\0') {
		___strtok = NULL;
		return( NULL );
	}
	send = strpbrk( sbegin, ct);
	if (send && *send != '\0')
		*send++ = '\0';
	___strtok = send;
	return (sbegin);
}

/**
 * strspn - Calculate the length of the initial substring of @s which only
 * 	contain letters in @accept
 * @s: The string to be searched
 * @accept: The string to search for
 */
size_t strspn(const char *s, const char *accept)
{
	const char *p;
	const char *a;
	size_t count = 0;

	for (p = s; *p != '\0'; ++p) {
		for (a = accept; *a != '\0'; ++a) {
			if (*p == *a)
				break;
		}
		if (*a == '\0')
			return count;
		++count;
	}

	return count;
}
