/*********************************************/
/*                                           */
/*pits_kernel/kernel.c:                      */
/*derived from linux/kernel.c                */
/*********************************************/
#include <stdarg.h>  /*for va_list */  
#include <linux/kernel.h>


/**********************************************/
/*printk(): Prints messages to the system log */
/**********************************************/

int printk(const char *fmt,...)
{
  va_list args;
  va_start(args,fmt);
  vprintf(fmt,args);
  va_end(args);

  return(0);
}

/**********************************************/
/*linux_panic(): Called by a driver whenever a*/
/*system panic occurs.  We should use this to */
/*completly disable the driver instead of     */
/*crashing the whole system.                  */
/**********************************************/
void linux_panic(const char *fmt,...)
{
  va_list ap;

  printk("Linux panic:");
  va_start(ap,fmt);
  vprintf(fmt,ap);
  va_end(ap);
  printk("\n");
}


