#include <sys/conf.h>
#include <sys/devops.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>
#include <sys/modctl.h>
#include <sys/stat.h>


#include <sys/cmn_err.h> /*this is for logging */

static void *statep;  /* for soft state routines?*/




/*forward references*/
/*Structures */
static struct modldrv pits_kernel_modldrv;
static struct cb_ops pits_kernel_cb_ops;
static struct dev_ops pits_kernel_dev_ops;


/*functions */
static int pits_kernel_getinfo(dev_info_t *dip,ddi_info_cmd_t infocmd, void *arg, void **result);
static int pits_kernel_probe(dev_info_t *dip);
static int pits_kernel_attach(dev_info_t *dip, ddi_attach_cmd_t cmd);
static int pits_kernel_detach(dev_info_t *dip,ddi_detach_cmd_t cmd);
int pits_kernel_power(dev_info_t *dip,int component,int level);


static struct modlinkage pits_kernel_modlinkage = {
  MODREV_1,  /* module version of the loading subsystem */
  &pits_kernel_modldrv, /* pointer to the driver modldrv structure */
  NULL /* NULL termination */
};

static struct modldrv pits_kernel_modldrv = {
  &mod_driverops, /* driver module operations */
  "pits_kernel driver v0.1", /* drv_linkinfo */
  &pits_kernel_dev_ops       /* drv_dev_ops */
};

static struct dev_ops pits_kernel_dev_ops = {
  DEVO_REV,    /* devo_rev : revision number of dev_ops structure*/
  0,           /* devo_refcnt : initialize to zero. */
  pits_kernel_getinfo,/* getinfo(9E) */ 
  nulldev,     /* identify (9E) */
  nulldev,  /* probe (9E) */
  pits_kernel_attach, /*attach (9E) */
  pits_kernel_detach, /*attach (9E) */
  nodev,       /* devo_reset */
  &pits_kernel_cb_ops,
  (struct bus_ops *)NULL,  /* devo_bus_ops */
  nulldev /* power (9E) */
};

static struct cb_ops pits_kernel_cb_ops =
{
  nodev, /*open */
  nodev, /*close */
  nodev, /*strategy*/
  nodev, /*print*/
  nodev, /*dump*/
  nodev, /*read*/
  nodev, /*write*/
  nodev, /*ioctl*/
  nodev, /*devmap*/
  nodev, /*mmap*/
  nodev, /*segmap*/
  nochpoll, /*no chpoll*/
  nodev, /*prop_op*/
  NULL,  /* streamtab - for streams (network) drivers */
  D_MP,   /*cb_flag D_MP means thread safe */
  CB_REV,  /*structure revision number*/
  nodev,
  nodev
};


