#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/dkio.h>
#include <sys/vtoc.h>
int main(int argc, char **argv)
{
  int fd;
  int i;
  struct dk_geom geom;
  struct dk_cinfo cinfo;
  struct vtoc vtoc;
  char buf[100];
  fd = open ("/dev/sbullr0", O_RDWR);
  printf("fd = %d\n", fd);
  printf("getting geometry\n");
  if (ioctl(fd,DKIOCGGEOM,&geom) >-1)
    {
      printf("dkg_ncyl: %d\n",geom.dkg_ncyl);
      printf("dkg_acyl: %d\n",geom.dkg_acyl);
      printf("dkg_bcyl: %d\n",geom.dkg_bcyl);
      printf("dkg_nhead:%d\n",geom.dkg_nhead);
      printf("dkg_nsect:%d\n",geom.dkg_nsect);
      printf("dkg_pcyl:%d\n",geom.dkg_pcyl);
    }
  else
    {
      printf("Error detected\n");
      perror("ioctl(DKIOCGGEOM):");
    }
  
  /*#define DK_DEVLEN   16 */   /* device name max length, */
                            /* including unit # and NULL */
                            /* Used for controller info */
  printf("getting cinfo\n");
  if (ioctl(fd,DKIOCINFO,&cinfo) > -1)
    {
      printf("dki_cname:%s\n",cinfo.dki_cname); /* controller name */
                                                /*(no unit #)*/
      printf("dki_ctype:%d\n",cinfo.dki_ctype); /* controller type */
      printf("dki_flags:%d\n",cinfo.dki_flags); /* flags */
      printf("dki_cnum:%d\n",cinfo.dki_cnum);   /* controller number */
      printf("dki_addr:%d\n",cinfo.dki_addr);   /* controller address */
      printf("dki_space:%d\n",cinfo.dki_space); /* controller bus type */
      printf("dki_prio:%d\n",cinfo.dki_prio);   /* interrupt priority */
      printf("dki_vec:%d\n",cinfo.dki_vec);     /* interrupt vector */
      printf("dki_dname:%s\n",cinfo.dki_dname); /* drive name (no unit #) */
      printf("dki_unit:%d\n",cinfo.dki_unit);   /* unit number */
      printf("dki_slave:%d\n",cinfo.dki_slave); /* slave number */
      printf("dki_partition:%d\n",cinfo.dki_partition); /* partition number */
      printf("dki_maxtransfer:%d\n",cinfo.dki_maxtransfer); /* maximum transfer size */
                                                            /* in DEV_BSIZE */
    }
  else
    {
      printf("Error detected\n");
      perror("ioctl(DKIOCINFO)\n");
    }
  printf("getting VTOC\n");
  
  if (ioctl(fd,DKIOCGVTOC,&vtoc) > -1)
    {
      printf("v_bootinfo[0]:%lu\n",vtoc.v_bootinfo[0]);
      printf("v_bootinfo[1]:%lu\n",vtoc.v_bootinfo[1]);
      printf("v_bootinfo[2]:%lu\n",vtoc.v_bootinfo[2]);
      printf("v_sanity:%lu\n",vtoc.v_sanity);
      printf("v_version:%lu\n",vtoc.v_version);
      printf("v_volume:%s\n",vtoc.v_volume);
      printf("v_sectorsz:%d\n",vtoc.v_sectorsz);
      printf("v_nparts:%d\n",vtoc.v_nparts);
      for (i=0;i<vtoc.v_nparts;i++)
	{
	  printf("v_parts[%d].p_tag:%d\n",i,vtoc.v_part[i].p_tag);
	  printf("v_parts[%d].p_flag:%d\n",i,vtoc.v_part[i].p_flag);
	  printf("v_parts[%d].p_start:%ld\n",i,vtoc.v_part[i].p_start);
	  printf("v_parts[%d].p_size:%ld\n",i,vtoc.v_part[i].p_size);
	  printf("timestamp[%d]:%s\n",i,ctime_r(vtoc.timestamp+i,buf,100));
	}
      printf("v_asciilabel:%s\n",vtoc.v_asciilabel);
    }
  else
    {
      printf("Error detected\n");
      perror("ioctl(DKIOCGVTOC)\n");
    }
  

    close(fd);
}
