/* t1.c
 *
 * the t1 set tests basic scull device
 *
 * - t1 writes "Hello, world!" to the device and then
 * reads it back
 *
 * - t1a tests ioctl calls
 *
 * - t1b runs t1 on all 4 scull devices
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int main(int argc, char **argv)
{
    int written, offset, received, fd;
    char buf[1024];
    char* mes;
    
    memset(buf, 0, 1024);
    
    fd = open ("/dev/scull", O_RDWR);

    printf("fd = %d\n", fd);
    
    mes = "Hello, world.";
    written = write ( fd, mes, 13);

    printf("written = %d\n", written);
    
    offset = lseek (fd, 0, SEEK_SET);

    printf("offset = %d\n", offset);
    
    received = read ( fd, buf, 1024 );

    printf("received = %d\n", received);

    printf("message = %s\n", buf);

    close(fd);
}
