/* t3a.c
 *
 * - t3a is an interactive writer -- user enters
 * target device number and message
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    int written, offset, fd[4], i, target;
    char buf[1024];
    char* mes;
    
    memset(buf, 0, 1024);
    
    fd[0] = open ("/dev/scullpipe0", O_WRONLY);
    fd[1] = open ("/dev/scullpipe1", O_WRONLY);
    fd[2] = open ("/dev/scullpipe2", O_WRONLY);
    fd[3] = open ("/dev/scullpipe3", O_WRONLY);

    printf("fd[4] = {%d, %d, %d, %d}\n", fd[0], fd[1], fd[2], fd[3]);
    
    for (;;)
    {
	printf("Enter target pipe number [0-3]: ");
        target = getchar();
	if ( target == 10 ) continue;  // handle empty line
	fgets(buf, 1000, stdin);  // eat up and additional chars
	if ( strlen(buf) > 1 || target < 48 || target > 51 )
	{
	    printf("Target must be 0-3\n");
	    continue;
	}
	target -= 48;
	
        printf("Enter string to send: ");
        fgets(buf, 1000, stdin);

        buf[strlen(buf)-1] = 0; // remove newline

        written = write ( fd[target], buf, strlen(buf));

        printf("written to scullpipe%d (%d): '%s'\n", 
			target, written, buf);
    }
	
    for ( i=0; i<4; i++ )
        close(fd[i]);
}
