/* t3b.c
 *
 * - t3b is a continuous reader that selects readability
 * on all 4 devices and prints to screen when 
 * something arrives
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int main(int argc, char **argv)
{
    int received, fd[4], i, bFound;
    char buf[64];
    char* mes;
    fd_set rfds;
    struct timeval tv;
    
    memset(buf, 0, 64);
    
    fd[0] = open ("/dev/scullpipe0", O_RDONLY);
    fd[1] = open ("/dev/scullpipe1", O_RDONLY);
    fd[2] = open ("/dev/scullpipe2", O_RDONLY);
    fd[3] = open ("/dev/scullpipe3", O_RDONLY);

    printf("fd[4] = {%d, %d, %d, %d}\n", fd[0], fd[1], fd[2], fd[3]);
    
    for(;;)
    {
        FD_ZERO(&rfds);
        FD_SET(fd[0], &rfds);
        FD_SET(fd[1], &rfds);
        FD_SET(fd[2], &rfds);
        FD_SET(fd[3], &rfds);
        /* Wait up to fifteen seconds. */
        tv.tv_sec = 15;
        tv.tv_usec = 0;
        
	printf("Listening for new data\n");
	
        if( select(7, &rfds, NULL, NULL, &tv) )
	{
            bFound = 0;
	    for (i=0; i<4; i++)
	    {
                if (FD_ISSET(fd[i], &rfds))
	        {
		   printf("Reading from scullpipe%d\n", i);
		   received = read (fd[i], buf, 50);
		   printf("Received (%d): %s\n", received, buf);
		   bFound = 1;
		   memset(buf, 0, 64);
		}
	    }
	    if ( !bFound )
		printf("Error in select code\n");
	}
        else
            printf("No data within fifteen seconds.\n");
    }        

    for ( i=0; i<4; i++ )
        close(fd[i]);
}
