/* t3c.c
 *
 * - t3c is a continuous writer that uses up all
 * space in the 4 pipes and then selects writable
 * until it can find some place to write more.
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    int written, fd[4], i, bFound;
    char buf[128];
    char* mes;
    fd_set wfds;
    struct timeval tv;
	    
    
    memset(buf, 65, 128);
    
    fd[0] = open ("/dev/scullpipe0", O_WRONLY);
    fd[1] = open ("/dev/scullpipe1", O_WRONLY);
    fd[2] = open ("/dev/scullpipe2", O_WRONLY);
    fd[3] = open ("/dev/scullpipe3", O_WRONLY);

    printf("fd[4] = {%d, %d, %d, %d}\n", fd[0], fd[1], fd[2], fd[3]);
    
    for (;;)
    {
        FD_ZERO(&wfds);
        FD_SET(fd[0], &wfds);
        FD_SET(fd[1], &wfds);
        FD_SET(fd[2], &wfds);
        FD_SET(fd[3], &wfds);
        /* Wait up to fifteen seconds. */
        tv.tv_sec = 15;
        tv.tv_usec = 0;

        printf("Looking for space for new data\n");

        if( select(7, NULL, &wfds, NULL, &tv) )
        {
            bFound = 0;
            for (i=0; i<4; i++)
            {
                if (FD_ISSET(fd[i], &wfds))
                {
                    printf("Writing to  scullpipe%d\n", i);
                    written = write ( fd[i], buf, 100);
                    printf("Written to %d (%d): %s\n", i, written, buf);
                    bFound = 1;
                }
	    }
            if ( !bFound )
                    printf("Error in select code\n");
        }
        else
            printf("No space within fifteen seconds.\n");
    }
	
    for ( i=0; i<4; i++ )
        close(fd[i]);
}
