/* t3d.c
 *
 * - t3d is an interactive  reader that reads 50 byte
 * chunks from the device selected by the user
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    int received, fd[4], i, target;
    char buf[64];
    
    memset(buf, 0, 64);
    
    fd[0] = open ("/dev/scullpipe0", O_RDONLY);
    fd[1] = open ("/dev/scullpipe1", O_RDONLY);
    fd[2] = open ("/dev/scullpipe2", O_RDONLY);
    fd[3] = open ("/dev/scullpipe3", O_RDONLY);

    printf("fd[4] = {%d, %d, %d, %d}\n", fd[0], fd[1], fd[2], fd[3]);
    
    for(;;)
    {
        printf("Enter pipe number to read [0-3]: ");
        target = getchar();
        if ( target == 10 ) continue;  // handle empty line
        fgets(buf, 50, stdin);  // eat up and additional chars
        if ( strlen(buf) > 1 || target < 48 || target > 51 )
        {
            printf("Target must be 0-3\n");
                continue;
        }
        target -= 48;

	memset(buf, 0, 64);
        printf("Reading from scullpipe%d\n", target);
	received = read (fd[target], buf, 50);
	printf("Received (%d): %s\n", received, buf);
    }        

    for ( i=0; i<4; i++ )
        close(fd[i]);
}
