/* ti1.c
 *
 * the ti set tests basic short device interuppt handling.
 * Assumes that pin 9 and pin 10 are attached on the
 * parallel port.
 *
 */

#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
//#include <sys/ddi.h>

//number of interrupts to simulate.
#define NINT 1
//seconds between each interrupt.
#define NSEC 5

void delay(int);

int main(int argc, char **argv)
{
    int written, offset, received, fd;
    char interrupt;
    char data;
    int i;
    int fd2;
    //open device short0
    fd = open ("/dev/short0", O_RDWR);

    fd2 = open("/dev/short2", O_RDWR);

    //print out file descriptor.
    printf("fd = %d\n", fd);
    printf("fd2 = %d\n",fd2);
    //send NINT interrupts to the device, by writing a
    //byte to the output port that has the most significant bit (pin 9).
    //set.  If pin 9 and 10 are jumpered, then the interrupt will be
    //registered..

    printf("writing 16 to device at short2");
    data = (char)16;
    write(fd2,&data,1);
    
    for (i=0;i<NINT;i++)
      {
	data = 0;
	write(fd,&data,1);
	delay(NSEC);
	//write a byte that will trigger an interrupt.
	interrupt = (char)(128 + i);
	printf("sending byte value %d to device\n",(128+i));
	write(fd,&interrupt,1);
	//delay NSEC per interrupt
	delay(NSEC);
	

      }
    
    close(fd);
    close(fd2);
}


/***************************/
/*quick delay code......   */
/***************************/
void delay(int nsec)
{
  int i;

  for (i=0;i<1000000 * NSEC;i++)
    {
      ;
    }
}
